<template>
 <div>
 <a-breadcrumb style="margin-left:10px;margin-top:5px;font-weight:bold;">

    <a-breadcrumb-item  @click="toPage()">
      <home-outlined />
      <span>任务分配</span>
    </a-breadcrumb-item>
    <a-breadcrumb-item>任务【{{taskName}}】</a-breadcrumb-item>
  </a-breadcrumb>
  </div>
  <div>
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
       <div v-if="oneuserflag">
          <a-button type="primary"  @click="handleAdd" preIcon="ant-design:plus-outlined">批量分配</a-button>
          </div>
          <!--
          <a-button  type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-dropdown v-if="selectedRowKeys.length > 0">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
        -->
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
         {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
         <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
         <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <RateTaskdeptModal @register="registerModal" @success="handleSuccess"></RateTaskdeptModal>
  </div>
</template>

<script lang="ts" name="rate-rateTaskdept" setup>
  import {onMounted, ref, computed, unref,toRaw,inject} from 'vue';
  import {BasicTable, useTable, TableAction} from '/@/components/Table';
  import {useModal} from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage'
  import RateTaskdeptModal from './components/RateTaskdeptModal.vue'
  import {columns, searchFormSchema} from './RateTaskdept.data';
  import {list, deleteOne, batchDelete, getImportUrl,getExportUrl,getOneTask,getTaskDeptDomainTreeList} from './RateTaskdept.api';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import { useRoute } from 'vue-router';
  import { useRouter } from 'vue-router';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useUserStore } from '/@/store/modules/user';
  import { HomeOutlined, UserOutlined } from '@ant-design/icons-vue';
  import { useTabs } from '/@/hooks/web/useTabs';
  const { closeCurrent, refreshPage, setTitle } = useTabs();
  const { createMessage } = useMessage();
  const userStore = useUserStore();
  const route = useRoute();
  const router = useRouter();
  const checkedKeys = ref<Array<string | number>>([]);
  const taskName = ref('');
  let rateTaskId = ref('');
  const oneuserflag = ref(true)
  const key = ref(1)

  //注册model
  const [registerModal, {openModal}] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '任务分配',
           api: list,
           columns,
           canResize:false,
           formConfig: {
              //labelWidth: 120,
              schemas: searchFormSchema,
              autoSubmitOnEnter:true,
              showAdvancedButton:true,
              fieldMapToNumber: [
              ],
              fieldMapToTime: [
              ],
            },
          defSort :{
             column: 'valindex',
             order: 'asc',

          },
           actionColumn: {
               width: 120,
               fixed:'right'
            },
            beforeFetch(params) {
              params.rateTaskId=rateTaskId
              params = Object.assign(params)
            },
      },
       exportConfig: {
            name:"任务分配",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {reload,setProps},{ rowSelection, selectedRowKeys }] = tableContext

onMounted(() => {
    rateTaskId = toRaw(route.query).id;
    
    //taskName.value = toRaw(route.query).taskName;
    
    getOneTask({id:rateTaskId}).then(rep=>{
    
    //console.log('-------------getOneTask: ', rep);
    taskName.value = rep.taskName;
    
    
  })
   
    
    if(!!rateTaskId){
    setProps({searchInfo:{rateTaskId:rateTaskId}});
    // reload()
      }

      
    })



   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
       key,
     });
  }
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
  //location. reload()
  key.value++;
      reload();
     //why mod 
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
        {
           label: '分配填报人',
           onClick: handleSetTaskuserContent.bind(null, record),
           ifShow: ()=> { 
            if(userStore.getUserInfo.id ==record['rateUser']){
              //oneuserflag.value = false
              return true
            }else{
              return false
            }
            
            
           }
         } ,

         {
           label: '重新分配',
           onClick: handleEdit.bind(null, record),
           ifShow: ()=> { 
            if(record['rateUserName']!=null&&userStore.getUserInfo.username ==record['optionUser'])
            return true
            else return false 
            }
         } , /** 
         {
           label: '分配部门',
           onClick: handleEdit.bind(null, record),
           ifShow: ()=> { 
            if(record['rateUserName']==null)
            return  true
            else return false
            }
         } ,
        
         {
           label: '删除',
           popConfirm: {
             title: '是否确认删除',
             confirm: handleDelete.bind(null, record),
           }
         } */
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
        /**
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, {
           label: '删除',
           popConfirm: {
             title: '是否确认删除',
             confirm: handleDelete.bind(null, record),
           }
         } */
       ]
   }

  /**
    * 分配填报人
   */
   function handleSetTaskuserContent(record: Recordable) {
    

     closeCurrent();

    router.push({path: '/rate/rateTaskuserList',query:{id:record.id,rateTaskId:record.rateTaskId}})
   }

  function toPage() {
    closeCurrent();
    router.push({path: '/rate/rateTaskList'})
    
   
   }


</script>

<style scoped>

</style>